'use strict';

// Generated by CoffeeScript 2.3.1
// ---------------------------------
// Requires

// Local
var DocPad, action, docpadConfig, docpadUtil, getArgument;

DocPad = require('../lib/docpad');

docpadUtil = require('../lib/util');

// ---------------------------------
// Helpers

// Prepare
getArgument = function getArgument(name) {
  var value = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;
  var defaultValue = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : null;

  var argumentIndex, result;
  result = defaultValue;
  argumentIndex = process.argv.indexOf('--' + name);
  if (argumentIndex !== -1) {
    result = value != null ? value : process.argv[argumentIndex + 1];
  }
  return result;
};

// DocPad Action
action = getArgument('action', null, 'server generate');

// ---------------------------------
// DocPad Configuration
docpadConfig = {};

docpadConfig.port = function () {
  var port;
  port = getArgument('port');
  if (port && isNaN(port) === false) {
    port = parseInt(port, 10);
  }
  return port;
}();

// ---------------------------------
// Create DocPad Instance
new DocPad(docpadConfig, function (err, docpad) {
  if (err) {
    // Check
    return docpadUtil.writeError(err);
  }
  // Generate and Serve
  return docpad.action(action, function (err) {
    if (err) {
      // Check
      return docpadUtil.writeError(err);
    }
    // Done
    return console.log('OK');
  });
});