'use strict';

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

// Generated by CoffeeScript 2.3.1
// =====================================
// Requires

// External
/**
 * Base class for the DocPad collection object
 * Extends the backbone.js collection object
 * http://backbonejs.org/#Collection
 * @class Collection
 * @constructor
 * @extends queryEngine.Backbone.Collection
 */
/**
 * Base class for the DocPad file and document model
 * Extends the backbone.js model
 * http://backbonejs.org/#Model
 * @class Model
 * @constructor
 * @extends queryEngine.Backbone.Model
 */
/**
 * Base class for the DocPad query collection object
 * Extends the bevry QueryEngine object
 * http://github.com/bevry/query-engine
 * @class QueryCollection
 * @constructor
 * @extends queryEngine.QueryCollection
 */
var Collection,
    Events,
    Model,
    QueryCollection,
    emit,
    extendr,
    log,
    queryEngine,
    hasProp = {}.hasOwnProperty,
    boundMethodCheck = function boundMethodCheck(instance, Constructor) {
  if (!(instance instanceof Constructor)) {
    throw new Error('Bound instance method accessed before binding');
  }
};

extendr = require('extendr');

queryEngine = require('query-engine');

// =====================================
// Helpers

// Log a message
log = function log() {
  for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
    args[_key] = arguments[_key];
  }

  args.unshift('log');
  this.emit.apply(this, args);
  return this;
};

emit = function emit() {
  for (var _len2 = arguments.length, args = Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
    args[_key2] = arguments[_key2];
  }

  return this.trigger.apply(this, args);
};

Events = function () {
  // =====================================
  // Classes

  // -------------------------------------
  // Backbone
  /**
   * Base class for the DocPad Events object
   * Extends the backbone.js events object
   * http://backbonejs.org/#Events
   * @class Events
   * @constructor
   * @extends queryEngine.Backbone.Events
   */
  var Events = function Events() {
    _classCallCheck(this, Events);
  };

  ;

  Events.prototype.log = log;

  Events.prototype.emit = emit;

  return Events;
}.call(undefined);

extendr.extend(Events.prototype, queryEngine.Backbone.Events);

Model = function () {
  var Model = function (_queryEngine$Backbone) {
    _inherits(Model, _queryEngine$Backbone);

    function Model() {
      _classCallCheck(this, Model);

      return _possibleConstructorReturn(this, (Model.__proto__ || Object.getPrototypeOf(Model)).apply(this, arguments));
    }

    _createClass(Model, [{
      key: 'setDefaults',

      // Set Defaults
      value: function setDefaults() {
        var attrs = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
        var opts = arguments[1];

        var key, ref, set, value;
        // Extract
        set = {};
        for (key in attrs) {
          if (!hasProp.call(attrs, key)) continue;
          value = attrs[key];
          if (this.get(key) === ((ref = this.defaults) != null ? ref[key] : void 0)) {
            set[key] = value;
          }
        }
        // Forward
        return this.set(set, opts);
      }
    }]);

    return Model;
  }(queryEngine.Backbone.Model);

  ;

  Model.prototype.log = log;

  Model.prototype.emit = emit;

  return Model;
}.call(undefined);

Collection = function () {
  var Collection = function (_queryEngine$Backbone2) {
    _inherits(Collection, _queryEngine$Backbone2);

    function Collection() {
      _classCallCheck(this, Collection);

      var _this2 = _possibleConstructorReturn(this, (Collection.__proto__ || Object.getPrototypeOf(Collection)).apply(this, arguments));

      _this2.destroy = _this2.destroy.bind(_this2);
      return _this2;
    }

    _createClass(Collection, [{
      key: 'destroy',
      value: function destroy() {
        boundMethodCheck(this, Collection);
        this.emit('destroy');
        this.off().stopListening();
        return this;
      }
    }]);

    return Collection;
  }(queryEngine.Backbone.Collection);

  ;

  Collection.prototype.log = log;

  Collection.prototype.emit = emit;

  return Collection;
}.call(undefined);

Collection.prototype.model = Model;

Collection.prototype.collection = Collection;

QueryCollection = function () {
  var QueryCollection = function (_queryEngine$QueryCol) {
    _inherits(QueryCollection, _queryEngine$QueryCol);

    function QueryCollection() {
      _classCallCheck(this, QueryCollection);

      var _this3 = _possibleConstructorReturn(this, (QueryCollection.__proto__ || Object.getPrototypeOf(QueryCollection)).apply(this, arguments));

      _this3.destroy = _this3.destroy.bind(_this3);
      return _this3;
    }

    _createClass(QueryCollection, [{
      key: 'setParentCollection',
      value: function setParentCollection() {
        var parentCollection;
        _get(QueryCollection.prototype.__proto__ || Object.getPrototypeOf(QueryCollection.prototype), 'setParentCollection', this).apply(this, arguments);
        parentCollection = this.getParentCollection();
        parentCollection.on('destroy', this.destroy);
        return this;
      }
    }, {
      key: 'destroy',
      value: function destroy() {
        boundMethodCheck(this, QueryCollection);
        this.emit('destroy');
        this.off().stopListening();
        return this;
      }
    }]);

    return QueryCollection;
  }(queryEngine.QueryCollection);

  ;

  QueryCollection.prototype.log = log;

  QueryCollection.prototype.emit = emit;

  return QueryCollection;
}.call(undefined);

QueryCollection.prototype.model = Model;

QueryCollection.prototype.collection = QueryCollection;

// =====================================
// Export our base models
module.exports = { Events: Events, Model: Model, Collection: Collection, QueryCollection: QueryCollection };