'use strict';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

// Generated by CoffeeScript 2.3.1
// =====================================
// Requires

// External
var Collection, ElementsCollection, Model, typeChecker;

typeChecker = require('typechecker');

// Local

var _require = require('../base');

Collection = _require.Collection;
Model = _require.Model;


ElementsCollection = function () {
  // =====================================
  // Classes
  /**
   * Base class for the DocPad Elements Collection object
   * Extends the DocPad collection class
   * https://github.com/docpad/docpad/blob/master/src/lib/base.coffee#L72
   * Used as the base collection class for specific collection of file types.
   * In particular metadata, scripts and styles.
   * @class ElementsCollection
   * @constructor
   * @extends Collection
   */
  var ElementsCollection = function (_Collection) {
    _inherits(ElementsCollection, _Collection);

    function ElementsCollection() {
      _classCallCheck(this, ElementsCollection);

      return _possibleConstructorReturn(this, (ElementsCollection.__proto__ || Object.getPrototypeOf(ElementsCollection)).apply(this, arguments));
    }

    _createClass(ElementsCollection, [{
      key: 'add',

      /**
       * Add an element to the collection.
       * Right now we just support strings.
       * @method add
       * @param {Array} values string array of values
       * @param {Object} opts
       */
      value: function add(values, opts) {
        var i, key, len, value;
        // Ensure array
        if (typeChecker.isArray(values)) {
          values = values.slice();
        } else if (values) {
          values = [values];
        } else {
          values = [];
        }
        // Convert string based array properties into html
        for (key = i = 0, len = values.length; i < len; key = ++i) {
          value = values[key];
          if (typeChecker.isString(value)) {
            values[key] = new Model({
              html: value
            });
          }
        }
        // Call the super with our values
        _get(ElementsCollection.prototype.__proto__ || Object.getPrototypeOf(ElementsCollection.prototype), 'add', this).call(this, values, opts);
        return this;
      }

      // Chain

    }, {
      key: 'set',
      value: function set() {
        _get(ElementsCollection.prototype.__proto__ || Object.getPrototypeOf(ElementsCollection.prototype), 'set', this).apply(this, arguments);
        return this;
      }
    }, {
      key: 'remove',
      value: function remove() {
        _get(ElementsCollection.prototype.__proto__ || Object.getPrototypeOf(ElementsCollection.prototype), 'remove', this).apply(this, arguments);
        return this;
      }
    }, {
      key: 'reset',
      value: function reset() {
        _get(ElementsCollection.prototype.__proto__ || Object.getPrototypeOf(ElementsCollection.prototype), 'reset', this).apply(this, arguments);
        return this;
      }

      /**
       * Create a way to output our elements to HTML
       * @method toHTML
       * @return {String}
       */

    }, {
      key: 'toHTML',
      value: function toHTML() {
        var html;
        html = '';
        this.forEach(function (item) {
          return html += item.get('html') || '';
        });
        return html;
      }

      // Join alias toHTML for b/c

    }, {
      key: 'join',
      value: function join() {
        return this.toHTML();
      }
    }]);

    return ElementsCollection;
  }(Collection);

  ;

  /**
   * Base Model for all items in this collection
   * @property {Object} model
   */
  ElementsCollection.prototype.model = Model;

  return ElementsCollection;
}.call(undefined);

// =====================================
// Export
module.exports = ElementsCollection;