'use strict';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

// Generated by CoffeeScript 2.3.1
// =====================================
// Requires

// Standard Library
var FileModel, FilesCollection, Model, QueryCollection, pathUtil;

pathUtil = require('path');

// Local

var _require = require('../base');

QueryCollection = _require.QueryCollection;
Model = _require.Model;


FileModel = require('../models/file');

FilesCollection = function () {
  // =====================================
  // Classes
  /**
   * The DocPad files and documents query collection class
   * Extends the DocPad QueryCollection class
   * https://github.com/docpad/docpad/blob/master/src/lib/base.coffee#L91
   * Used as the query collection class for DocPad files and documents.
   * This differs from standard collections in that it provides backbone.js,
   * noSQL style methods for querying the file system. In DocPad this
   * is the various files that make up a web project. Typically this is the documents,
   * css, script and image files.
   *
   * Most often a developer will use this class to find (and possibly sort) documents,
   * such as blog posts, by some criteria.
   * 	posts: ->
   * 		@getCollection('documents').findAllLive({relativeOutDirPath: 'posts'},[{date:-1}])
   * @class FilesCollection
   * @constructor
   * @extends QueryCollection
   */
  var FilesCollection = function (_QueryCollection) {
    _inherits(FilesCollection, _QueryCollection);

    function FilesCollection() {
      _classCallCheck(this, FilesCollection);

      return _possibleConstructorReturn(this, (FilesCollection.__proto__ || Object.getPrototypeOf(FilesCollection)).apply(this, arguments));
    }

    _createClass(FilesCollection, [{
      key: 'initialize',

      /**
       * Initialize the collection
       * @private
       * @method initialize
       * @param {Object} attrs
       * @param {Object} [opts={}]
       */
      value: function initialize(attrs) {
        var opts = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

        var base;
        if (this.options == null) {
          this.options = {};
        }
        if ((base = this.options).name == null) {
          base.name = opts.name || null;
        }
        return _get(FilesCollection.prototype.__proto__ || Object.getPrototypeOf(FilesCollection.prototype), 'initialize', this).apply(this, arguments);
      }

      /**
       * Fuzzy find one
       * Useful for layout searching
       * @method fuzzyFindOne
       * @param {Object} data
       * @param {Object} sorting
       * @param {Object} paging
       * @return {Object} the file, if found
       */

    }, {
      key: 'fuzzyFindOne',
      value: function fuzzyFindOne(data, sorting, paging) {
        var escapedData, file, i, len, queries, query;
        // Prepare
        escapedData = data != null ? data.replace(/[\/]/g, pathUtil.sep) : void 0;
        queries = [{
          relativePath: escapedData
        }, {
          relativeBase: escapedData
        }, {
          url: data
        }, {
          relativePath: {
            $startsWith: escapedData
          }
        }, {
          fullPath: {
            $startsWith: escapedData
          }
        }, {
          url: {
            $startsWith: data
          }
        }];
        // Try the queries
        for (i = 0, len = queries.length; i < len; i++) {
          query = queries[i];
          file = this.findOne(query, sorting, paging);
          if (file) {
            return file;
          }
        }
        // Didn't find a file
        return null;
      }
    }]);

    return FilesCollection;
  }(QueryCollection);

  ;

  /**
   * Base Model for all items in this collection
   * @private
   * @property {Object} model
   */
  FilesCollection.prototype.model = FileModel;

  /**
   * Base Collection for all child collections
   * @private
   * @property {Object} collection
   */
  FilesCollection.prototype.collection = FilesCollection;

  return FilesCollection;
}.call(undefined);

// =====================================
// Export
module.exports = FilesCollection;