'use strict';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

// Generated by CoffeeScript 2.3.1
// =====================================
// Requires

// External
var ElementsCollection, StylesCollection, typeChecker;

typeChecker = require('typechecker');

// Local
ElementsCollection = require('./elements');

// =====================================
// Classes
/**
 * Styles collection class. A DocPad
 * project's style (css) file paths
 * @class StylesCollection
 * @constructor
 * @extends ElementsCollection
 */
StylesCollection = function (_ElementsCollection) {
  _inherits(StylesCollection, _ElementsCollection);

  function StylesCollection() {
    _classCallCheck(this, StylesCollection);

    return _possibleConstructorReturn(this, (StylesCollection.__proto__ || Object.getPrototypeOf(StylesCollection)).apply(this, arguments));
  }

  _createClass(StylesCollection, [{
    key: 'add',

    /**
     * Add an element to the collection
     * Right now we just support strings
     * @method add
     * @param {Array} values string array of file paths
     * @param {Object} opts
     */
    value: function add(values, opts) {
      var i, key, len, value;
      // Prepare
      opts || (opts = {});
      opts.attrs || (opts.attrs = '');
      // Ensure array
      if (typeChecker.isArray(values)) {
        values = values.slice();
      } else if (values) {
        values = [values];
      } else {
        values = [];
      }
      // Convert urls into script element html
      for (key = i = 0, len = values.length; i < len; key = ++i) {
        value = values[key];
        if (typeChecker.isString(value)) {
          if (value[0] === '<') {
            continue; // we are an element already, don't bother doing anything
          } else if (value.indexOf(' ') === -1) {
            // we are a url
            values[key] = '<link ' + opts.attrs + ' rel="stylesheet" href="' + value + '" />';
          } else {
            // we are inline
            values[key] = '<style ' + opts.attrs + '>' + value + '</style>';
          }
        }
      }
      // Call the super with our values
      return _get(StylesCollection.prototype.__proto__ || Object.getPrototypeOf(StylesCollection.prototype), 'add', this).call(this, values, opts);
    }
  }]);

  return StylesCollection;
}(ElementsCollection);

// =====================================
// Export
module.exports = StylesCollection;