// Generated by CoffeeScript 2.3.1
// ---------------------------------
// Requires

// Local
var DocPad, action, docpadConfig, docpadUtil, getArgument;

DocPad = require('../lib/docpad');

docpadUtil = require('../lib/util');

// ---------------------------------
// Helpers

// Prepare
getArgument = function(name, value = null, defaultValue = null) {
  var argumentIndex, result;
  result = defaultValue;
  argumentIndex = process.argv.indexOf(`--${name}`);
  if (argumentIndex !== -1) {
    result = value != null ? value : process.argv[argumentIndex + 1];
  }
  return result;
};

// DocPad Action
action = (getArgument('action', null, 'generate') + ' ' + getArgument('watch', 'watch', '')).trim();

// ---------------------------------
// DocPad Configuration
docpadConfig = {};

docpadConfig.rootPath = getArgument('rootPath', null, process.cwd());

docpadConfig.outPath = getArgument('outPath', null, docpadConfig.rootPath + '/out');

docpadConfig.srcPath = getArgument('srcPath', null, docpadConfig.rootPath + '/src');

docpadConfig.documentsPaths = (function() {
  var documentsPath;
  documentsPath = getArgument('documentsPath');
  if (documentsPath != null) {
    if (documentsPath === 'auto') {
      documentsPath = docpadConfig.srcPath;
    }
  } else {
    documentsPath = docpadConfig.srcPath + '/documents';
  }
  return [documentsPath];
})();

docpadConfig.port = (function() {
  var port;
  port = getArgument('port');
  if (port && isNaN(port) === false) {
    port = parseInt(port, 10);
  }
  return port;
})();

docpadConfig.renderSingleExtensions = (function() {
  var renderSingleExtensions;
  renderSingleExtensions = getArgument('renderSingleExtensions', null, 'auto');
  if (renderSingleExtensions === 'true' || renderSingleExtensions === 'yes') {
    renderSingleExtensions = true;
  } else if (renderSingleExtensions === 'false' || renderSingleExtensions === 'no') {
    renderSingleExtensions = false;
  }
  return renderSingleExtensions;
})();

// ---------------------------------
// Create DocPad Instance
new DocPad(docpadConfig, function(err, docpad) {
  if (err) {
    // Check
    return docpadUtil.writeError(err);
  }
  // Generate and Serve
  return docpad.action(action, function(err) {
    if (err) {
      // Check
      return docpadUtil.writeError(err);
    }
    // Done
    return console.log('OK');
  });
});
