// Generated by CoffeeScript 2.3.1
  // ---------------------------------
  // Check node version right away
var checkDocPad, docpadUtil, startDocPad,
  indexOf = [].indexOf;

if (process.versions.node.indexOf('0') === 0 && process.versions.node.split('.')[1] % 2 !== 0) {
  console.log(require('util').format("== WARNING ==\n   DocPad is running against an unstable version of Node.js (v%s to be precise).\n   Unstable versions of Node.js WILL break things! Do not use them with DocPad!\n   Run DocPad with a stable version of Node.js (e.g. v%s) for a stable experience.\n   For more information, visit: %s\n== WARNING ===", process.versions.node, "0." + (process.versions.node.split('.')[1] - 1), "http://docpad.org/unstable-node"));
}

// Prepare
docpadUtil = require('../lib/util');

// ---------------------------------
// Check for Local DocPad Installation
checkDocPad = function() {
  // Skip if we explcitly want to use the global installation
  if (indexOf.call(process.argv, '--global') >= 0 || indexOf.call(process.argv, '--g') >= 0) {
    return startDocPad();
  }
  // Skip if we are already the local installation
  if (docpadUtil.isLocalDocPadExecutable()) {
    return startDocPad();
  }
  // Skip if the local installation doesn't exist
  if (docpadUtil.getLocalDocPadExecutableExistance() === false) {
    return startDocPad();
  }
  // Forward to the local installation
  return docpadUtil.startLocalDocPadExecutable();
};

// ---------------------------------
// Start our DocPad Installation
startDocPad = function() {
  var ConsoleInterface, DocPad, action;
  // Require
  DocPad = require('../lib/docpad');
  ConsoleInterface = require('../lib/interfaces/console');
  // Fetch action
  // we should eventually do a load always
  // but as it is a big change of functionality, lets only do it inclusively for now
  action = process.argv.slice(1).join(' ').indexOf('deploy') !== -1 ? 'load' : false; // if we are the deploy command // if we are not the deploy command
  // Create DocPad Instance
  return new DocPad({action}, function(err, docpad) {
    if (err) {
      // Check
      return docpadUtil.writeError(err);
    }
    // Create Console Interface
    return new ConsoleInterface({docpad}, function(err, consoleInterface) {
      if (err) {
        // Check
        return docpadUtil.writeError(err);
      }
      // Start
      return consoleInterface.start();
    });
  });
};

// ---------------------------------
// Fire
checkDocPad();
